;****NOTE****: The Button must have the "BS_NOTIFY" style to send the notification Code "BN_KILLFOCUS"
;If a resourse rsrc.rc is used this must be changed there to "True", The Defult is "False"
.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc 
include  \masm32\include\shell32.inc


includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib 
includelib  \masm32\lib\shell32.lib
include 	\masm32\include\msimg32.inc
includelib 	\masm32\lib\msimg32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	   equ 101
IDI_ICON       equ 200
IDC_CLOSE      equ 102
CLOSEBMP       equ 100
CLOSEBMP1      equ 300
; Required data

.data

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
rct RECT   <?>

.code

start:



INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls

INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT

INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL hCloseBmp:HANDLE
LOCAL hCloseBmp1:HANDLE

	.IF uMsg == WM_INITDIALOG
; Load the Defult image for the close button
    invoke LoadBitmap, hInstance,100
; Assign the Defult image to the close button
	invoke SendDlgItemMessage, hWnd, IDC_CLOSE, BM_SETIMAGE, IMAGE_BITMAP, eax

;  Create rounded corners

INVOKE GetClientRect,hWnd,offset rct
INVOKE CreateRoundRectRgn,0,0,rct.right,rct.bottom,20,20
INVOKE SetWindowRgn,hWnd,eax,TRUE

.ELSEIF  uMsg == WM_COMMAND
mov eax,wParam
mov edx,eax
shr edx,16
and eax,0ffffh

.IF edx == BN_CLICKED
.IF eax ==IDC_CLOSE
   INVOKE SendMessage,hWnd,WM_CLOSE,0,0
  .ENDIF
  .ENDIF
.IF edx == BN_KILLFOCUS
.IF eax ==IDC_CLOSE
; Load the image for the close button
    invoke LoadBitmap, hInstance,300
; Assign the image to the button
	invoke SendDlgItemMessage, hWnd, IDC_CLOSE, BM_SETIMAGE, IMAGE_BITMAP, eax

  .ENDIF
  .ENDIF
.IF edx == BN_SETFOCUS
.IF eax ==IDC_CLOSE
; Load the image for the close button
    invoke LoadBitmap, hInstance,100
; Assign the image to the button
	invoke SendDlgItemMessage, hWnd, IDC_CLOSE, BM_SETIMAGE, IMAGE_BITMAP, eax

  .ENDIF
  .ENDIF
;Move the window when the user presses the left mouse button while the cursor is within the 
;nonclient area of a window. 
.ELSEIF uMsg == WM_LBUTTONDOWN
INVOKE SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0

.ELSEIF uMsg == WM_RBUTTONUP
INVOKE ShowWindow,hWnd,SW_MINIMIZE  	; Minimize Window Button     
   
    .ELSEIF  uMsg == WM_CLOSE
   
    INVOKE EndDialog, hWnd, 0
    .ENDIF
 

    xor eax,eax
  ret
DialogProc endp

end start